function [A,p,s]=Bunch_Kaufmann(A);
% global n;
if nargin < 1
    n=5;
  A=rand(n);
  
end
n=size(A,1);
k=1;
p=zeros(n,1);
s=ones(n,1);
alpha=(sqrt(17)+1)/8;
k=1;
while 1
    [lambda,r]=max(abs(A(k+1:n,k)));
    if lambda==0
        k=k+1;
    else
        if abs(A(k,k))>alpha*lambda  % A(k,k) is a pivot with no permutation
            l=A(k+1:n,k)';
            A(k+1:n,k)=A(k+1:n,k)./A(k,k);
            A(k+1:n,k+1:n)=A(k+1:n,k+1:n)-A(k+1:n,k)*l;
            k=k+1;
        else
            r=min(r)+k;  % determine the detailed position of r in the original matrix;
            sigma=max(abs([A(k:r-1,r);A(r+1:n,r) ]));   % ??
            if abs(A(r,r))>=alpha*sigma  % permute r and k, 1-pivot
                p(k)=r;
                a=A(k,:);
                A(k,:)=A(r,:);
                A(r,:)=a;
                b=A(:,k);
                A(:,k)=A(:,r);
                A(:,r)=b;
                l=A(k+1:n,k)';
                A(k+1:n,k)=A(k+1:n,k)./A(k,k);
                A(k+1:n,k+1:n)=A(k+1:n,k+1:n)-A(k+1:n,k)*l;
                k=k+1;
            else
                if alpha*lambda^2<=abs(A(k,k))*sigma   % NO permutation with A(k,k) pivot
                    l=A(k+1:n,k)';
                    A(k+1:n,k)=A(k+1:n,k)./A(k,k);
                    A(k+1:n,k+1:n)=A(k+1:n,k+1:n)-A(k+1:n,k)*l;
                    k=k+1;
                else          % interchange k+1 and r, 2-2 pivot 
                    s(k)=2;
                    p(k+1)=r;
                    a=A(k+1,:);
                    A(k+1,:)=A(r,:);
                    A(r,:)=a;
                    b=A(:,k+1);
                    A(:,k+1)=A(:,r);
                    A(:,r)=b;
                    c=equation_solver(A(k:k+1,k:k+1), A(k+2:n,k:k+1)');
                    A(k+2:n,k+2:n)=A(k+2:n,k+2:n)-c'*A(k:k+1,k+2:n);
                    A(k+2:n,k:k+1)=c';
                    k=k+2;
                end
            end
        end
    end
    if k>n-1
        break;
    end
end
% L=speye(n);
% D=zeros(n);
% D(1,1)=A(1,1);
% i=1;
% while 1
%     if s(i)==1
%         L(i,1:i-1)=A(i,1:i-1);
%         D(i,i)=A(i,i);
%         i=i+1;
%     elseif s(i)==2
%         L(i:i+1,1:i-1)=A(i:i+1,1:i-1);
%         D(i:i+1,i:i+1)=A(i:i+1,i:i+1);
%         i=i+2;
%     end
%     if i > n
%         break;
%     end
% end
% for i=1:n
%     if p(i)~=0
%         a=B(i,:);
%         B(i,:)=B(p(i),:);
%         B(p(i),:)=a;
%         b=B(:,i);
%         B(:,i)=B(:,p(i));
%         B(:,p(i))=b;
%     end
% end
% p
% s
% L
% D
% full(L*D*L')
% B
% norm(full(L*D*L')-B)

function c=equation_solver(A,b);  % solve 2-order equation
m=size(b,2);
c=zeros(2,m);
det_whole=A(1,1)*A(2,2)-A(1,2)^2;
det_subwhole=zeros(2,m);
det_subwhole(1,:)=b(1,:)*A(2,2)-b(2,:)*A(1,2);
det_subwhole(2,:)=A(1,1)*b(2,:)-A(1,2)*b(1,:);
c=det_subwhole./det_whole;

