function  [fail,x_star,Iter,Inner_Iter,time]=aggregate_deformation_homotopy(x0,Iter_max,epison,epison_corrector,step_max,step_min,step);
global x_initial;
global theta;
global Iter;
global Inner_Iter;
global para;
global n;
global num_obj;
global num_con;
global alpha_initial;
global con_initial;
global beta_1;
global beta_2;
global rou;
global p;
global inexact;

if nargin < 1
    x0=zeros(n,1);
end
if nargin < 7
    step=0.1;
end
if nargin < 6
    step_min=1e-3;
end
if nargin < 5
    step_max=1;
end
if nargin < 4
    epison_corrector=1e-3;
end
if nargin < 3
    epison=1e-6;
end
if nargin < 2
    Iter_max=100*n;
end
alpha_initial=ones(2,1);
alpha0=alpha_initial;
Iter=0;
Inner_Iter=0;
time=0;
z0=[x0;alpha0];
fail.value=0;
fail.step=0;
fail.iter=0;

[f,f_min]=myfun_obj(n,num_obj,x0,1);
[f_t,grad_f_x]=myfun_con_grad_aggregate(f,f_min,x0,1,num_obj,1,0);
[g,g_min]=myfun_con(n,num_con,x0,1);
[g_t,grad_g_x_1,grad_g_t_1]=myfun_con_grad_aggregate(g,g_min,x0,1,num_con,1,1);
grad_g_x=zeros(n,2);
% grad_g_x(:,1)=(1-t)^beta_1*grad_g_x_1;  % deformation
grad_g_x(:,1)=zeros(n,1);  % deformation
grad_g_x(:,2)=2*x0;
grad_g_t=zeros(2,1);
% grad_g_t(1)=beta_1*(1-t)^(beta_1-1)*grad_g_t_1+(1-t)^beta_1*g_t-t^beta_2*rou;
grad_g_t(1)=-rou;

d_t=-1;
d_x=-(grad_f_x+grad_g_x*alpha0);
d_alpha=alpha0.*(-con_initial+grad_g_t-(d_x'*grad_g_x)')./con_initial;
dir=[d_x;d_alpha;d_t];
dir=dir./norm(dir);

num=0;
stop=0;
z1=z0;
t1=1;
fail_1=0;
tic
while stop==0
    if step < 10^(-10)
        fprintf('Failure for short step!\n');
        fail.step=1;
        break;
    end
    predict=1;
    while predict    %ΪУʧܻԤĿƽ沽ҪظԤ
        if Iter > Iter_max
            fprintf('Fail for too many iterations!\n');
            fail.iter=1;
            stop=1;
            break;
        end
        if step < 10^(-10)
            fprintf('Failure for short step!\n');
            fail.step=1;
            stop=1;
            break;
        end
        step=min(step_max,step);
        first_z=z1+step*dir(1:end-1);
        first_t=t1+step*dir(end);
        
        if first_t < 0 | first_t>1
            step=step/2;
        else
            if para.Newton==1
                [z2,t2,dir,k,flag]=Newton(first_z,first_t,dir,epison_corrector);
%                  t2
%                 dir(end-2:end)
%                 k
%                 step
            else
                [z2,t2,dir,k,flag]=Quasi_Newton(first_z,first_t,dir,epison_corrector);
            end
            if flag==0
                step=step*0.5;
                num=0;
                fail_1=fail_1+1;
                if fail_1>30
                    fprintf('Newton_end Iter failue!\n ');
                    fail.iter=1;
                    stop=1;
                    break;
                end
            else
%                 t2
%                 z2(end-1:end)
%                 k
%                 step
                fail_1=0;
                z1=z2;
                t1=t2;
                Iter=Iter+1; 
                if abs(t1) < epison
                    stop=1;
                    break
                end
                num=num+1;
                if num>3 & k<3
                    step=step*2;
                    num=0;
                    
                end
                if k>5
                    step=step*0.7;
                end
            end
        end
    end
end
time=toc;
if flag==0 |  step < 10^(-10) | fail_1>30 % | Iter > Iter_max
    x_star=[];
    Iter=[];
    Inner_Iter=[];
    time=[];
    fail.value=1;
    fprintf('Failure!\n');
else
    x_star=z1(1:n);
end
return

