function     [h,H]=find_equation_solution(x,alpha,t,first_x,first_alpha,first_t,dir);
global n;
global num_obj;
global num_con;
global x_initial;
global alpha_initial;
global con_initial;
global theta;
global rou;
global p;
global beta_1;
global beta_2;
global para;
global inexact;

obj_length=length(num_obj);
con_length=length(num_con);
u=theta*t;
a=[x-first_x;alpha-first_alpha;t-first_t];

[f,f_min]=myfun_obj(n,num_obj,x,1);
[g,g_min]=myfun_con(n,num_con,x,1);
[f_t,grad_f_x,grad_f_t,hes_f_xx,hes_f_xt]=myfun_con_grad_aggregate(f,f_min,x,t,num_obj,3,0);
if inexact==0
   [g_t_1,grad_g_x_1,grad_g_t_1,hes_g_xx_1,hes_g_xt_1]=myfun_con_grad_aggregate(g, g_min,x,t,num_con,3,1);
else
    l=length(num_con);
    [Index.Out, Index.Inner]=find_index(g, g_min,t,l); 
    [g_t_1,grad_g_x_1,grad_g_t_1,hes_g_xx_1,hes_g_xt_1]=myfun_grad_aggregate_inexact(g,g_min,x,t,3,1,Index.Out, Index.Inner);
end
g_t=zeros(2,1);
grad_g_x=zeros(n,2);
% g_t(1)=(1-t)^beta_1*g_t_1-t^beta_2*rou; % aggregate deformation function
g_t(1)=(1-t)^beta_1*(g_t_1-u*log(con_length))-t^beta_2*rou; % aggregate deformation function

if para.bound==1
    g_t(2)=x'*x-p;
else
    g_t(2)=x'*x-p/t;
end
grad_g_x(:,1)=(1-t)^beta_1*grad_g_x_1;
grad_g_x(:,2)=2*x;
grad_g_t=zeros(2,1);

grad_g_t(1)=-beta_1*(1-t)^(beta_1-1)*(g_t_1-u*log(con_length))+...
    (1-t)^beta_1*(grad_g_t_1-theta*log(con_length))-beta_2*t^(beta_2-1)*rou;
if para.bound==0
    grad_g_t(2)=p/t^2;
end
H=[(1-t)*(grad_f_x+grad_g_x*alpha) + t*(x-x_initial);
    alpha.*g_t-t*alpha_initial.*con_initial];
if first_t<1e-3
    dir=[zeros(n+2,1);1];
    L=[-H;0];
else
    L=-[H;dir'*a];
end
hes_g_xx_1=(1-t)^beta_1*hes_g_xx_1;
hes_g_xt_1=-beta_1*(1-t)^(beta_1-1)*grad_g_x_1+(1-t)^beta_1*hes_g_xt_1;
% hes_g_xt=zeros(n,2);
% hes_g_xt(:,1)=-beta_1*(1-t)^(beta_1-1)*grad_g_x_1+(1-t)^beta_1*hes_g_xt_1;
A1=(1-t)*(hes_f_xx+hes_g_xx_1*alpha(1))+(t+alpha(2)*(1-t))*speye(n);

DH=[A1                             (1-t)*grad_g_x                       x-x_initial+(1-t)*(hes_f_xt+hes_g_xt_1*alpha(1))-(grad_f_x+grad_g_x*alpha);
    diag(alpha)*grad_g_x'           diag(g_t)                          -alpha_initial.*con_initial+alpha.*grad_g_t];
DL=[DH; dir'];

h=DL\L;

return

% if obj_length==1 & con_length==1
%     if num_obj~=1 & num_con==1  % the obj-function is min-function, con is a smooth function
% %         modified.coe=(1-t)/u;
% %         modified.vec=grad_f_x;
%         A1=A1+(1-t)/u*grad_f_x*grad_f_x';
%     elseif num_obj==1& num_con~=1
% %         modified.coe=alpha(1)*(1-t)^(beta_1+1)/u;
% %         modified.vec=grad_g_x_1;
%         A1=A1+alpha(1)*(1-t)^(beta_1+1)/u*grad_g_x_1*grad_g_x_1';
%     else
% %         modified.coe=[(1-t)/u; alpha(1)*(1-t)^(beta_1+1)/u];
% %         modified.vec=[grad_f_x; grad_g_x_1];
%         A1=A1+(1-t)/u*(grad_f_x*grad_f_x'+alpha(1)*(1-t)^beta_1*grad_g_x_1*grad_g_x_1');
%     end
% elseif obj_length~=1 & num_con==1  % the obj-function is max-function or max-min function and the constraints if a smooth function
% %         modified.coe=-(1-t)/u;
% %         modified.vec=grad_f_x;
%     A1=A1-(1-t)/u*grad_f_x*grad_f_x';
% elseif num_obj==1 & con_length~=1  % the con-function is max-function  or max-min function and the constraints if a smooth function
% %         modified.coe=-alpha(1)*(1-t)^(beta_1+1)/u;
% %         modified.vec=grad_g_x_1;
%    A1=A1-alpha(1)*(1-t)^(beta_1+1)/u*grad_g_x_1*grad_g_x_1';
% 
% else
% %         modified.coe=[(1-t)/u; alpha(1)*(1-t)^(beta_1+1)/u];
% %         modified.vec=[grad_f_x; grad_g_x_1];
%     A1=A1-(1-t)/u*(grad_f_x*grad_f_x'-alpha(1)*(1-t)^beta_1*grad_g_x_1*grad_g_x_1');
% end
% % [A1,p,s]=Bunch_Kaufmann(A1)
% % b1= (1-t)*grad_g_x ;
% % b2= x-x_initial+(1-t)*(hes_f_xt+hes_g_xt*alpha)-(grad_f_x+grad_g_x*alpha);
% % b3=[alpha(1)*grad_g_x(:,1)';alpha(2)*grad_g_x(:,2)'];
% % b4=diag(g_t);
% % b5=-alpha_initial.*con_initial+alpha.*grad_g_t;
% % d1=dir(1:n);
% % d2=dir(n+1:end-1);
% % d3=dir(end);
% % len_modi=length(modified.coe);
% % if len_modi==1  % rank-1 modification
% %     modi_1=B_K_solver(A1,p,s,modified.vec);
% % else
% % end
% % y1=B_K_solver(A1,p,s,b1);
% % y2=B_K_solver(A1,p,s,b2);
% % y3=B_K_solver(A1,p,s,L(1:n));
% % 
% % % the solution after rank-one modification (A-1/tgg')^(-1)=A^(-1)
% % if  len_modi==1
% %     y1=y1+(modi_1*(modi_vec'*y1))/(-modi_1-modi_vec'*modi_1);
% %     y2=y2+(modi_1*(modi_vec'*y2))/(-modi_1-modi_vec'*modi_1);
% %     y3=y3+(modi_1*(modi_vec'*y3))/(-modi_1-modi_vec'*modi_1);
% %     B1=[b4-b3*y1 b5-b3*y2;
% %         d2-d1'*y1 d3-d1'*y2];
% %     L1=[L(n+1:end-1)-b3*y3; L(end)-d1'*y3];
% %     h1=Pivot_Gauss(B1,L1);
% %     a1=L(1:n)-b1*h1(n+1:end-1)-b2*h1(end);
% %     h0=B_K_solver(A1,p,s,a1);
% %     h0=h0+(modi_1*(modi_vec'*h0))/(-modi_1-modi_vec'*modi_1);
% % else
% % end
% % h=[h0;h1];


% function     h=Pivot_Gauss(A,b);

