function    [Index_Out, Index_Inner]=find_index(f, f_min, t, m);
global Inner_num_con;
global theta;

Index_Inner=cell(m,1);
%M_inner=1e+10;
M_inner=find_M_inner(t,Inner_num_con);
u_i=cell(m,1);
sum_u_i=zeros(m,1);
f_i_t=zeros(m,1);
u=theta*t;

for i=1:m
    Index_Inner{i}=find(f_min(i)-f{i}> -M_inner);   % compute the inner inexact index
     u_i{i}=exp((-f{i}(Index_Inner{i})+f_min(i))./u);
    sum_u_i(i)=sum(u_i{i});
    f_i_t(i)=-u*log(sum_u_i(i))+f_min(i);
end

max_f_i_t=max(f_i_t);
bound_g=max(abs(f_i_t));
%      M_out=1e+10;
M_out=find_M_out(t,m);
Index_Out=find(f_i_t - max_f_i_t > -M_out);

return


function     M=find_M_inner(t,maxJ);
global theta;
epsilon_H=1e-3;
epsilon_DH=1;
t_theta=t*theta;
bound_grad=100;
bound_hess=100;
bound_g=100;
bound_alpha=100;

if maxJ==1
    M=1e10;
else
 
    a_H=((1-t)*3*bound_grad+t_theta)*bound_alpha;
    a_DH=(1-t)*(3*bound_hess+19/t_theta*bound_grad^2)*bound_alpha+3*(2*bound_alpha+1-t)*bound_grad+(1-t)*bound_alpha*(14/(t*t_theta)*bound_grad*bound_g)...
        +t_theta+bound_alpha*(theta+3/t*bound_g);

    if t==1
        M=t_theta*log((maxJ-1)*a_DH/epsilon_DH);
    else
        term=max(a_H/epsilon_H,a_DH/epsilon_DH);
        M=t_theta*log((maxJ-1)*term);
    end
end

function     M=find_M_out(t,m);
global theta;
epsilon_H=1e-3;
epsilon_DH=1;
t_theta=t*theta;
bound_grad=10;
bound_hess=10;
bound_g=10;
bound_alpha=10;

if m==1
    M=1e10;
else
    a_H=((1-t)*2*bound_grad+t_theta)*bound_alpha;
    a_DH=2*(1-t)*(bound_hess+5/t_theta*bound_grad^2)*bound_alpha+2*(2*bound_alpha+1-t)*bound_grad+(1-t)*bound_alpha*(10/(t*t_theta)*bound_grad*bound_g)...
        +t_theta+bound_alpha*(theta+2/t*bound_g);
    if t==1
        M=t_theta*log((m-1)*a_DH/epsilon_DH);
    else
        term=max(a_H/epsilon_H,a_DH/epsilon_DH);
        M=t_theta*log((m-1)*term);

    end
end


