function         dir=find_tangent(z,t,dir);
global n;
global num_obj;
global num_con;
global x_initial;
global alpha_initial;
global con_initial;
global theta;
global rou;
global p;
global beta_1;
global beta_2;
global para;
global inexact;

x=z(1:n);
alpha=z(n+1:end);

u=theta*t;
obj_length=length(num_obj);
con_length=length(num_con);

[f,f_min]=myfun_obj(n,num_obj,x,1); 
[g,g_min]=myfun_con(n,num_con,x,1);

[f_t,grad_f_x,grad_f_t,hes_f_xx,hes_f_xt]=myfun_con_grad_aggregate(f,f_min,x,t,num_obj,3,0);
if inexact==0
   [g_t_1,grad_g_x_1,grad_g_t_1,hes_g_xx_1,hes_g_xt_1]=myfun_con_grad_aggregate(g, g_min,x,t,num_con,3,1);
else
    l=length(num_con);
    [Index.Out, Index.Inner]=find_index(g, g_min,t,l); 
    [g_t_1,grad_g_x_1,grad_g_t_1,hes_g_xx_1,hes_g_xt_1]=myfun_grad_aggregate_inexact(g,g_min,x,t,3,1,Index.Out, Index.Inner);
end

g_t=zeros(2,1);
grad_g_x=zeros(n,2);
g_t(1)=(1-t)^beta_1*g_t_1-t^beta_2*rou; % aggregate deformation function
if para.bound==1
    g_t(2)=x'*x-p;
else
    g_t(2)=x'*x-p/t;
end

grad_g_x(:,1)=(1-t)^beta_1*grad_g_x_1;
grad_g_x(:,2)=2*x;
L=[zeros(n+2,1);1];
grad_g_t=zeros(2,1);
grad_g_t(1)=-beta_1*(1-t)^(beta_1-1)*g_t_1+(1-t)^beta_1*grad_g_t_1-beta_2*t^(beta_2-1)*rou;
if para.bound==0
    grad_g_t(2)=p/t^2;
end
hes_g_xx_1=(1-t)^beta_1*hes_g_xx_1;
hes_g_xt_1=-beta_1*(1-t)^(beta_1-1)*grad_g_x_1+(1-t)^beta_1*hes_g_xt_1;
% hes_g_xt=zeros(n,2);
% hes_g_xt(:,1)=-beta_1*(1-t)^(beta_1-1)*grad_g_x_1+(1-t)^beta_1*hes_g_xt_1;

A1=(1-t)*(hes_f_xx+hes_g_xx_1*alpha(1))+(t+alpha(2)*(1-t))*speye(n);

DH=[A1                             (1-t)*grad_g_x                       x-x_initial+(1-t)*(hes_f_xt+hes_g_xt_1*alpha(1))-(grad_f_x+grad_g_x*alpha);
    diag(alpha)*grad_g_x'           diag(g_t)                          -alpha_initial.*con_initial+alpha.*grad_g_t];
DL=[DH; dir'];
dir=DL\L;
dir=dir./norm(dir);

return

% if obj_length==1 & con_length==1
%     if num_obj~=1 & num_con==1  % the obj-function is min-function, con is a smooth function
%         A1=A1+(1-t)/u*grad_f_x*grad_f_x';
%     elseif num_obj==1& num_con~=1
%         A1=A1+alpha(1)*(1-t)^(beta_1+1)/u*grad_g_x_1*grad_g_x_1';
%     else
%         A1=A1+(1-t)/u*(grad_f_x*grad_f_x'+alpha(1)*(1-t)^beta_1*grad_g_x_1*grad_g_x_1');
%     end
% elseif obj_length~=1 & num_con==1 % the obj-function is max-function or max-min function and the constraints if a smooth function
%     A1=A1-(1-t)/u*grad_f_x*grad_f_x';
% elseif num_obj==1 & con_length~=1 % the con-function is max-function  or max-min function and the constraints if a smooth function
%     A1=A1-alpha(1)*(1-t)^(beta_1+1)/u*grad_g_x_1*grad_g_x_1';
% else
%     A1=A1-(1-t)/u*(grad_f_x*grad_f_x'+alpha(1)*(1-t)^beta_1*grad_g_x_1*grad_g_x_1');
% end

