function [f,f_min,grad,hes]=myfun_con_ex2(n,num_con,x,option);  
global N;
T=x(1);
u1=x(2:N+1);
u2=x(N+2:2*N+1); 
m=length(num_con);
x1=0.3;
x2=0.25;
alpha=0.25;
beta=0.2;
C=1e-6;
nu=0;
theta=0;
w=0;
if option==1
    f=cell(m,1);
    f_min=zeros(m,1);
    for i=1:N
        x1=x1+T/N*nu*cos(theta);
        x2=x2+T/N*nu*sin(theta);
        nu=nu+T/N*u1(i);
        theta=theta+T/N*w;
        w=w+T/N*u2(i);
         f{i}=[x1-alpha beta-x2]';
        f{N+i}=[-x1-alpha beta-x2]';
        f{2*N+i}=-x2;
        f{3*N+i}=nu-1;
        f{4*N+i}=-nu-1;
        f_min(i)=min(f{i});
        f_min(N+i)=min(f{N+i});
        f_min(2*N+i)=f{2*N+i};
        f_min(3*N+i)=f{3*N+i};
        f_min(4*N+i)=f{4*N+i}; 
        f{5*N+i}=-u1(i)-2;
        f{6*N+i}=u1(i)-2;
        f{7*N+i}=-u2(i)-pi/4;
        f{8*N+i}=u2(i)-pi/4;
        f_min(5*N+i)=f{5*N+i};
        f_min(6*N+i)=f{6*N+i};
        f_min(7*N+i)=f{7*N+i};
        f_min(8*N+i)=f{8*N+i};
    end  
    f{9*N+1}=x1-C/N;
    f{9*N+2}=-x1-C/N;
    f{9*N+3}=x2-C/N;
    f{9*N+4}=-x2-C/N;
    f{9*N+5}=theta-C/N;
    f{9*N+6}=-theta-C/N;
    f{9*N+7}=nu-C/N;
    f{9*N+8}=-nu-C/N;
    f{9*N+9}=w-C/N;
    f{9*N+10}=-w-C/N;
    f_min(9*N+1)=f{9*N+1};
    f_min(9*N+2)=f{9*N+2};
    f_min(9*N+3)=f{9*N+3};
    f_min(9*N+4)=f{9*N+4};
    f_min(9*N+5)=f{9*N+5};
    f_min(9*N+6)=f{9*N+6};
    f_min(9*N+7)=f{9*N+7};
    f_min(9*N+8)=f{9*N+8};
    f_min(9*N+9)=f{9*N+9};
    f_min(9*N+10)=f{9*N+10};
    f{9*N+11}=2-T;
    f_min(9*N+11)=f{9*N+11};
elseif option==2
    grad=cell(m,1);
    partial_x1_T=0;
    partial_x2_T=0;
    partial_theta_T=0;
    partial_w_T=0;
    partial_nu_T=0;
    partial_x1_u1=zeros(N,1);
    partial_x2_u1=zeros(N,1);
    partial_nu_u1=zeros(N,1);
    partial_x1_u2=zeros(N,1);
    partial_x2_u2=zeros(N,1);
    partial_theta_u2=zeros(N,1);
    partial_w_u2=zeros(N,1);
    e=zeros(N,1);
    for i=1:N
        x1=x1+T/N*nu*cos(theta);  
        partial_x1_T=partial_x1_T+1/N*(nu*cos(theta)+T*(partial_nu_T*cos(theta)-nu*sin(theta)*partial_theta_T));
        partial_x1_u1=partial_x1_u1+T/N*cos(theta)*partial_nu_u1;
        partial_x1_u2=partial_x1_u2-T/N*sin(theta)*nu*partial_theta_u2;

        x2=x2+T/N*nu*sin(theta);
        partial_x2_T=partial_x2_T+1/N*(nu*sin(theta)+T*(partial_nu_T*sin(theta)+nu*cos(theta)*partial_theta_T));
        partial_x2_u1=partial_x2_u1+T/N*sin(theta)*partial_nu_u1;
        partial_x2_u2=partial_x2_u2+T/N*cos(theta)*nu*partial_theta_u2;
        
        nu=nu+T/N*u1(i);
        partial_nu_T=partial_nu_T+1/N*u1(i);
        e(i)=1;
        partial_nu_u1=partial_nu_u1+T/N*e;
        e(i)=0;
        
        theta=theta+T/N*w;
        partial_theta_T=partial_theta_T+1/N*(w+T*partial_w_T);
        partial_theta_u2=partial_theta_u2+T/N*partial_w_u2;
        
        w=w+T/N*u2(i);
        partial_w_T=partial_w_T+1/N*u2(i);
        e(i)=1;
        partial_w_u2=partial_w_u2+T/N*e;
        e(i)=0;
        
        partial_x1=[partial_x1_T;partial_x1_u1;partial_x1_u2];
        partial_x2=[partial_x2_T;partial_x2_u1;partial_x2_u2];
        partial_nu=[partial_nu_T;partial_nu_u1;zeros(N,1)];
        
        e(i)=1;
        partial_u1=[0;e;zeros(N,1)];
        partial_u2=[zeros(N+1,1);e];
        e(i)=0;
        
        grad{i}=[partial_x1 -partial_x2];
        grad{N+i}=[-partial_x1 -partial_x2];
        grad{2*N+i}=-partial_x2;
        grad{3*N+i}=partial_nu;
        grad{4*N+i}=-partial_nu;
        grad{5*N+i}=-partial_u1;
        grad{6*N+i}=partial_u1;
        grad{7*N+i}=-partial_u2;
        grad{8*N+i}=partial_u2;
    end  
    grad{9*N+1}=partial_x1;
    grad{9*N+2}=-partial_x1;
    grad{9*N+3}=partial_x2;
    grad{9*N+4}=-partial_x2;
    grad{9*N+5}=[partial_theta_T;zeros(N,1);partial_theta_u2];
    grad{9*N+6}=-grad{9*N+5};
    grad{9*N+7}=partial_nu;
    grad{9*N+8}=-partial_nu;
    grad{9*N+9}=[partial_w_T;zeros(N,1);partial_w_u2];
    grad{9*N+10}=-grad{9*N+9};
    grad{9*N+11}=[-1;zeros(2*N,1)];
    f=[];f_min=[];

elseif option==3
    hes=cell(m,1);
%     partial_x1_T=0;
%     partial_x2_T=0;
    partial_theta_T=0;
    partial_w_T=0;
    partial_nu_T=0;
%     partial_x1_u1=zeros(N,1);
%     partial_x2_u1=zeros(N,1);
    partial_nu_u1=zeros(N,1);
%     partial_x1_u2=zeros(N,1);
%     partial_x2_u2=zeros(N,1);
    partial_theta_u2=zeros(N,1);
    partial_w_u2=zeros(N,1);
    
    partial_x1_T_T=0;
    partial_x1_T_u1=zeros(N,1);
    partial_x1_T_u2=zeros(N,1);
    partial_x1_u1_u2=zeros(N);
    partial_x1_u2_u2=zeros(N);

    partial_x2_T_T=0;
    partial_x2_T_u1=zeros(N,1);
    partial_x2_T_u2=zeros(N,1);
    partial_x2_u1_u2=zeros(N);
    partial_x2_u2_u2=zeros(N);
    
    partial_nu_T_u1=zeros(N,1);
    partial_theta_T_T=0;
    partial_theta_T_u2=zeros(N,1);
    
    partial_w_T_u2=zeros(N,1);
    
    hes_x1=zeros(n^2,1);
    hes_x2=zeros(n^2,1);
    a=zeros(n^2,1);
    e=zeros(N,1);
    for i=1:N
        hes_x1=reshape(hes_x1,n,n);
        hes_x2=reshape(hes_x2,n,n);
        x1=x1+T/N*nu*cos(theta);  
%         partial_x1_T=partial_x1_T+1/N*(nu*cos(theta)+T*(partial_nu_T*cos(theta)-nu*sin(theta)*partial_theta_T));
%         partial_x1_u1=partial_x1_u1+T/N*cos(theta)*partial_nu_u1;
%         partial_x1_u2=partial_x1_u2-T/N*sin(theta)*nu*partial_theta_u2;
        
        partial_x1_T_T=partial_x1_T_T+1/N*(2*(partial_nu_T*cos(theta)-nu*sin(theta)*partial_theta_T)-...
            T*(2*sin(theta)*partial_nu_T*partial_theta_T+nu*cos(theta)*partial_theta_T^2+nu*sin(theta)*partial_theta_T_T));
        
        partial_x1_T_u1=partial_x1_T_u1+1/N*(cos(theta)*partial_nu_u1+...
             T*(cos(theta)*partial_nu_T_u1-sin(theta)*partial_theta_T*partial_nu_u1));
         
         partial_x1_T_u2=partial_x1_T_u2-1/N*(sin(theta)*nu*partial_theta_u2+...
             T*(cos(theta)*nu*partial_theta_T*partial_theta_u2+sin(theta)*partial_nu_T*partial_theta_u2+sin(theta)*nu*partial_theta_T_u2));
         
         partial_x1_u1_u2=partial_x1_u1_u2-T/N*sin(theta)*partial_theta_u2*partial_nu_u1';
         partial_x1_u2_u2=partial_x1_u2_u2-T/N*nu*cos(theta)*partial_theta_u2*partial_theta_u2';
         
         hes_x1(1,:)=[partial_x1_T_T partial_x1_T_u1' partial_x1_T_u2'];
         hes_x1(2:N+1,1)=partial_x1_T_u1;
         hes_x1(2:N+1,N+2:end)=partial_x1_u1_u2;
         hes_x1(N+2:end,:)=[partial_x1_T_u2 partial_x1_u1_u2 partial_x1_u2_u2];
         hes_x1=reshape(hes_x1,n^2,1);
         
        x2=x2+T/N*nu*sin(theta);
%         partial_x2_T=partial_x2_T+1/N*(nu*sin(theta)+T*(partial_nu_T*sin(theta)+nu*cos(theta)*partial_theta_T));
%         partial_x2_u1=partial_x2_u1+T/N*sin(theta)*partial_nu_u1;
%         partial_x2_u2=partial_x2_u2+T/N*cos(theta)*nu*partial_theta_u2;
        
        partial_x2_T_T=partial_x2_T_T+1/N*(2*(partial_nu_T*sin(theta)+nu*cos(theta)*partial_theta_T)+...
            T*(2*cos(theta)*partial_nu_T*partial_theta_T-nu*sin(theta)*partial_theta_T^2+nu*cos(theta)*partial_theta_T_T));
        
        partial_x2_T_u1=partial_x2_T_u1+1/N*(sin(theta)*partial_nu_u1+...
             T*(sin(theta)*partial_nu_T_u1+cos(theta)*partial_theta_T*partial_nu_u1));
         
         partial_x2_T_u2=partial_x2_T_u2+1/N*(cos(theta)*nu*partial_theta_u2+...
             T*(-sin(theta)*nu*partial_theta_T*partial_theta_u2+cos(theta)*partial_nu_T*partial_theta_u2+cos(theta)*nu*partial_theta_T_u2));
         
         partial_x2_u1_u2=partial_x2_u1_u2+T/N *cos(theta)*partial_theta_u2*partial_nu_u1';
         
         partial_x2_u2_u2=partial_x2_u2_u2-T/N*nu*sin(theta)*partial_theta_u2*partial_theta_u2';
         
         hes_x2(1,:)=[partial_x2_T_T partial_x2_T_u1' partial_x2_T_u2'];
         hes_x2(2:N+1,1)=partial_x2_T_u1;
         hes_x2(2:N+1,N+2:end)=partial_x2_u1_u2;
         hes_x2(N+2:end,:)=[partial_x2_T_u2 partial_x2_u1_u2 partial_x2_u2_u2];
         hes_x2=reshape(hes_x2,n^2,1);
         
         nu=nu+T/N*u1(i);
         partial_nu_T=partial_nu_T+1/N*u1(i);
         e(i)=1;
         partial_nu_u1=partial_nu_u1+T/N*e;
         partial_nu_T_u1=partial_nu_T_u1+1/N*e;
         e(i)=0;
    
        theta=theta+T/N*w;
        partial_theta_T=partial_theta_T+1/N*(w+T*partial_w_T);
        partial_theta_u2=partial_theta_u2+T/N*partial_w_u2;
        
        partial_theta_T_T=partial_theta_T_T+2/N*partial_w_T;
        partial_theta_T_u2=partial_theta_T_u2+1/N*(partial_w_u2+T*partial_w_T_u2);
        
        w=w+T/N*u2(i);
        partial_w_T=partial_w_T+1/N*u2(i);
        e(i)=1;
        partial_w_u2=partial_w_u2+T/N*e;
        partial_w_T_u2=partial_w_T_u2+1/N*e;
        e(i)=0;
        
        hes{i}=[hes_x1 -hes_x2];
        hes{N+i}=-[hes_x1 hes_x2];
        hes{2*N+i}=-hes_x2;   
        a(2:N+1)=0;
        a(n+1:n:n*N+1)=0;

        hes{5*N+i}=a;
        hes{6*N+i}=a;
        hes{7*N+i}=a;
        hes{8*N+i}=a;
        a(2:N+1)=partial_nu_T_u1;
        a(n+1:n:n*N+1)=partial_nu_T_u1';
        hes{3*N+i}=a;
        hes{4*N+i}=-a;
    end  
    
    hes{9*N+1}=hes_x1;
    hes{9*N+2}=-hes_x1;
    hes{9*N+3}=hes_x2;
    hes{9*N+4}=-hes_x2;
    hes{9*N+5}=reshape([partial_theta_T_T zeros(1,N) partial_theta_T_u2';zeros(N,2*N+1);partial_theta_T_u2 zeros(N,2*N)],n^2,1);
    hes{9*N+6}=-hes{9*N+5};
    hes{9*N+7}=a;
    hes{9*N+8}=-a;
    hes{9*N+9}=reshape([zeros(1,N+1) partial_w_T_u2';zeros(N,1+2*N);partial_w_T_u2 zeros(N,2*N)],n^2,1);
    hes{9*N+10}=-hes{9*N+9};
    hes{9*N+11}=zeros(n^2,1);
    grad=[];f=[];f_min=[];
elseif option==4
end