function [g_t,grad_g_x,grad_g_t,hes_g_xx,hes_g_xt]=myfun_grad_aggregate(g,g_min,x,t,num,option,con);

% compute the twice aggregate function: function value, gradient and
% hessian
% g--a cell, g{i}---corresponds the function(s) in min_i part 
% num---  the number of min-function
% option--0: compute the function value, 1: compute the gradient, 2:
% compute hessian, 3: compute the whole
% con--- is used to judge the computed function is the objective function
% or  the constraints (that is essential)

% if option==0, only compute the g_t
% if option==1, compute the grad_g_x,grad_g_t
% option==2, hessian
% option==3, the whole 
global n;
global theta;
global hes;
global hes_con;
u=theta*t;
m=length(num);

if m==1 & num==1 % only one smooth function no need for aggregate
    if option==0
        g_t=g_min;
    end
    if option==1 
        if con==1
            [f,f1,grad_g]=myfun_con(n,num,x,2);
        else
            [f,f1,grad_g]=myfun_obj(n,num,x,2);
        end
        grad_g_x=grad_g{1};
        grad_g_t=0;
        g_t=[];
    end
    if option==2 
        if con==1
            [f1,f2,f3,hes_g]=myfun_con(n,num,x,3);
        else
            [f1,f2,f3,hes_g]=myfun_obj(n,num,x,3);
%              hes_g=hes;
        end
        hes_g_xx=hes_g{1};
        hes_g_xt=zeros(n,1);
        g_t=[];
        grad_g_x=[];
        grad_g_t=[];
    end
    if option==3
        g_t=g_min;
        if con==1
            [f,f1,grad_g]=myfun_con(n,num,x,2);
        else
            [f,f1,grad_g]=myfun_obj(n,num,x,2);
        end
        grad_g_x=grad_g{1};
        grad_g_t=0;
        if con==1
            [f,f1,f2,hes_g]=myfun_con(n,num,x,3);
        else
                   [f,f1,f2,hes_g]=myfun_obj(n,num,x,3);
%             hes_g=hes;
        end
        hes_g_xx=reshape(hes_g{1},n,n);
        hes_g_xt=zeros(n,1);
    end
elseif m==1 & num~=1  % f(x)=min f_i(x),  inner-smoothing
    min_g_min=min(g_min);
    s=exp((min_g_min-g_min)./u);
    sum_s=sum(s);
    
    if option==0 
        g_t=-u*log(sum_s)+min_g_min;
    else
        g_t=-u*log(sum_s)+min_g_min;
        lambda=s./sum_s; 
        if con==1
            [f,f1,grad_g]=myfun_con(n,num,x,2);
        else
            [f,f1,grad_g]=myfun_obj(n,num,x,2);
        end
      
        grad_g_x=grad_g{1}*lambda; 
        mean_g=g_min'*lambda;
        
        if option==1 
            grad_g_t=(g_t-mean_g)/t;
        end
        if option==2   % no compute the grad_g_t
            if con==1
                [f,f1,f2,hes_g]=myfun_con(n,num,x,3);
            else
                [f,f1,f2,hes_g]=myfun_obj(n,num,x,3);
            end
            hes_g_xx=reshape(hes_g{1}*lambda,n,n);
            a=repmat(lambda,1,n)';
            a=reshape(a,n*m,1);
            b=reshape(grad_g,n*m,1);
            hes_g_xx=hes_g_xx-1/u*(reshape(a.*b,n,m)*grad_g'-grad_g_x*grad_g_x');  %  no leave +1/u*grad_g_x*grad_g_x' to make a rank-one modification
            hes_g_xt=1/(u*t)*grad_g*(lambda.*(g_min-mean_g));
            grad_g_t=[];
        end
        if option==3
            if con==1
                [f,f1,f21,hes_g]=myfun_con(n,num,x,3);
            else
                [f,f1,f21,hes_g]=myfun_obj(n,num_obj,x,3);
            end
            hes_g_xx=reshape(hes_g{1}*lambda,n,n);;
            a=repmat(lambda,1,n)';
            a=reshape(a,n*m,1);
            b=reshape(grad_g,n*m,1);
            hes_g_xx=hes_g_xx-1/u*(reshape(a.*b,n,m)*grad_g'-grad_g_x*grad_g_x');  % leave +1/u*grad_g_x*grad_g_x' to make a rank-one modification
            hes_g_xt=1/(u*t)*grad_g*(lambda.*(g_min-mean_g));
            grad_g_t=(g_t-mean_g)/t;
        end
    end
elseif m~=1 & num==ones(m,1)   % f=max f_i(x)
    max_g=max(g_min);
    s=exp((g_min-max_g)./u);
    sum_s=sum(s);
    if option==0 
        g_t=u*log(sum_s)+max_g;
    else
        if con==1
            [f1,f,grad_g]=myfun_con(n,num,x,2);
        else
            [f1,f,grad_g]=myfun_obj(n,num,x,2);
        end
        lambda=s./sum_s;
        grad_g_x=[grad_g{1:end}]*lambda;
        mean_g=[g{1:end}]*lambda;
        g_t=u*log(sum_s)+max_g;
        
        if option==1 
            grad_g_t=(g_t-mean_g)/t;
        end
        if option==2
            if con==1
                [f,f1,f2,hes_g]=myfun_con(n,num,x,3);
            else
                [f,f1,f2,hes_g]=myfun_obj(n,num,x,3);
%                   hes_g=hes_f;
            end
            hes_g_xx=reshape([hes_g{1:end}]*lambda,n,n);
            a=repmat(lambda,1,n)';
            a=reshape(a,n*m,1);
            b=reshape(grad_g,n*m,1);
             hes_g_xx=hes_g_xx+1/u*(reshape(a.*b,n,m)*[grad_g{1:end}]'-grad_g_x*grad_g_x');  % no leave -1/u*grad_g_x*grad_g_x' to make a rank-one modification
            hes_g_xt=-1/(u*t)*[grad_g{1:end}]*(lambda.*([g{1:end}]'-mean_g));
            grad_g_t=[];
        end
        if option==3
            g_t=u*log(sum_s)+max_g;
            if con==1
                [f,f1,f2,hes_g]=myfun_con(n,num,x,3);
            else
                [f,f1,f2,hes_g]=myfun_obj(n,num,x,3);
%                   hes_g=hes_f;
            end
            hes_g_xx=reshape([hes_g{1:end}]*lambda,n,n);
            a=repmat(lambda,1,n)';
            a=reshape(a,n*m,1);
            b=reshape([grad_g{1:end}],n*m,1);
            hes_g_xx=hes_g_xx+1/u*(reshape(a.*b,n,m)*[grad_g{1:end}]'-grad_g_x*grad_g_x');  %  no leave -1/u*grad_g_x*grad_g_x' to make a rank-one modification
            hes_g_xt=-1/(u*t)*[grad_g{1:end}]*(lambda.*([g{1:end}]'-mean_g));
            grad_g_t=(g_t-mean_g)/t;
        end
    end
else
    g_i_t=zeros(m,1);                   % save the inner aggregate
    sum_i=zeros(m,1);                   % save the inner sum
    inner_i=cell(m,1);                  % save the inner part of the sum
    for i=1:m
        inner_i{i}=exp( (-g{i}+g_min(i))./u );
        sum_i(i)=sum( inner_i{i} );
        g_i_t(i)=-u*log(sum_i(i))+g_min(i);
    end
    max_g_i_t=max(g_i_t);               % the maximal value of the inner aggregate function 
    a=exp((g_i_t-max_g_i_t)./u);
    sum_g_t=sum(a);
    if option==0
        g_t=u*log(sum_g_t)+max_g_i_t;
    else
        g_t=u*log(sum_g_t)+max_g_i_t;   % the aggregate function used to compute the grad_g_t
        lambda=a./sum_g_t ;            % the outer coeficient
        delta=cell(m,1);                % the inner coeficient
        grad_g_x=zeros(n,1); 
        grad_g_i_t=zeros(m,1);          % save the t-gradient for the inner aggregate function
        grad_g_i_x=zeros(n,m);          % save the x-gradient of the inner aggregate function
        if con==1
            [f,f1,grad_g]=myfun_con(n,num,x,2);    
        else
            [f,f1,grad_g]=myfun_obj(n,num,x,2);    
            
        end
        mean_g_i=zeros(m,1);            % save the mean value of the inner function
        mean_grad_g_i=zeros(n,m);
        for i=1:m
            delta{i}=inner_i{i}./sum_i(i);  % column vector 
            grad_g_i_x(:,i)=grad_g{i}*delta{i};
            mean_g_i(i)=delta{i}'*g{i};
            mean_grad_g_i(:,i)=grad_g{i}*(delta{i}.*(g{i}-mean_g_i(i)));
            grad_g_i_t(i)=(g_i_t(i)-mean_g_i(i))/t;
        end
        
        grad_g_x=grad_g_i_x*lambda;
        mean_g=mean_g_i'*lambda;
        if option==1
            grad_g_t=(g_t-lambda'*(g_i_t-t*grad_g_i_t))/t;
        end
        if option==2   % no compute the grad_g_t
            if con==1
                [f,f1,f2,hes_g]=myfun_con(n,num,x,3);
            else
                [f,f1,f2,hes_g]=myfun_obj(n,num,x,3);
                
            end
            [mean_hes_g_i,hes_g_compute]=myfun_hes_mean(hes_g,grad_g,delta);
            hes_g_xx=(mean_hes_g_i-hes_g_compute./u)*lambda;
            a=repmat(lambda,1,n)';
            a=reshape(a,n*m,1);
            b=reshape(grad_g_i_x,n*m,1);
            a=a.*b;
            c=reshape(a,n,m)*grad_g_i_x';
            hes_g_xx=hes_g_xx+1/u*(2*c-grad_g_x*grad_g_x');   % ignore -1/u*grad_g_x*grad_g_x' to make rank-one modification
            %             hes_g_xx=hes_g_xx+1/u*(2*reshape(c,n^2,1)-grad_g_x*grad_g_x');   % ignore -1/u*grad_g_x*grad_g_x' to make rank-one modification
            
            hes_g_xt=1./(u*t)*(grad_g_i_x*(lambda.*(-mean_g_i+mean_g)) +mean_grad_g_i*lambda);
            grad_g_t=[];
        end
        if option==3
            if con==1
              [f,f1,f2,hes_g]=myfun_con(n,num,x,3);
%                   hes_g=hes_con;
            else
                [f,f1,f2,hes_g]=myfun_obj(n,num,x,3);
%                  hes_g=hes_f;
            end
            [mean_hes_f_i,hes_f_compute]=myfun_hes_mean(hes_g,grad_g,delta);
            hes_g_xx=reshape((mean_hes_f_i-hes_f_compute./u)*lambda,n,n);
            a=repmat(lambda,1,n)';
            a=reshape(a,n*m,1);
            b=reshape(grad_g_i_x,n*m,1);
            a=a.*b;
            c=reshape(a,n,m)*grad_g_i_x';
            hes_g_xx=hes_g_xx+1/u*(2*c-grad_g_x*grad_g_x');  % ignore -1/u*grad_g_x*grad_g_x' to make rank-one modification        end
            %             hes_g_xx=hes_g_xx+1/u*(2*reshape(c,n^2,1)-reshape(grad_g_x*grad_g_x',n^2,1));   % ignore -1/u*grad_g_x*grad_g_x' to make rank-one modification
            
            hes_g_xt=1./(u*t)*(grad_g_i_x*(lambda.*(-mean_g_i+mean_g)) +mean_grad_g_i*lambda);
            grad_g_t=(g_t-lambda'*(g_i_t-grad_g_i_t))/t;
        end
    end
end
return

function [ mean_hes_g_i,hes_g_compute]=myfun_hes_mean(hes_g,grad_g,delta);
global n;
m=size(delta,1);
mean_hes_g_i=zeros(n^2,m);
hes_g_compute=zeros(n^2,m);
for i=1:m
    l=length(delta{i});
    mean_hes_g_i(:,i)=hes_g{i}*delta{i};
    a=repmat(delta{i},1,n)';
    a=reshape(a,l*n,1);
    b=reshape(grad_g{i},l*n,1);
    a=reshape(a.*b,n,l);
    hes_g_compute(:,i)=reshape(a*grad_g{i}',n^2,1);
end
return