function [g_t,grad_g_x,grad_g_t,hes_g_xx,hes_g_xt]=myfun_grad_aggregate_inexact(g,g_min,x,t,option,con,Index_Out, Index_Inner);
% compute the twice aggregate function: function value, gradient and
% hessian
% g--a cell, g{i}---corresponds the function(s) in min_i part
% num---  the number of min-function
% option--0: compute the function value, 1: compute the gradient, 2:
% compute hessian, 3: compute the whole
% con--- is used to judge the computed function is the objective function
% or  the constraints (that is essential)

% if option==0, only compute the g_t
% if option==1, compute the grad_g_x,grad_g_t
% option==2, hessian
% option==3, the whole
global n;
global theta;
global hes;
global hes_con;
global num_con;
u=theta*t;
m=length(Index_Out);
l=length(num_con);
g_i_t=zeros(m,1);                   % save the inner aggregate
sum_i=zeros(m,1);                   % save the inner sum
inner_i=cell(m,1);                  % save the inner part of the sum
for i=1:l
%     s1=Index_Inner{Index_Out(i)};
    inner_i{i}=exp( (-g{i}(Index_Inner{i})+g_min(i))./u );
    sum_i(i)=sum( inner_i{i} );
    g_i_t(i)=-u*log(sum_i(i))+g_min(i);
end
max_g_i_t=max(g_i_t);               % the maximal value of the inner aggregate function
a=exp((g_i_t-max_g_i_t)./u);
sum_g_t=sum(a(Index_Out));
if option==0
    g_t=u*log(sum_g_t)+max_g_i_t;
else
    g_t=u*log(sum_g_t)+max_g_i_t;   % the aggregate function used to compute the grad_g_t
    lambda=a(Index_Out)./sum_g_t ;            % the outer coeficient
    delta=cell(m,1);                % the inner coeficient
    grad_g_x=zeros(n,1);
    grad_g_i_t=zeros(m,1);          % save the t-gradient for the inner aggregate function
    grad_g_i_x=zeros(n,m);          % save the x-gradient of the inner aggregate function
    if con==1
        [f,f1,grad_g]=myfun_con_inexact(n,num_con,x,2,Index_Out,Index_Inner);
    else
        [f,f1,grad_g]=myfun_obj(n,num,x,2);
    end
    mean_g_i=zeros(m,1);            % save the mean value of the inner function
    mean_grad_g_i=zeros(n,m);
    g_inexact=cell(m,1);
    for i=1:m   
        delta{i}=inner_i{Index_Out(i)}./sum_i(i);  % column vector
        grad_g_i_x(:,i)=grad_g{i}*delta{i};
        g_inexact{i}=g{Index_Out(i)}(Index_Inner{Index_Out(i)});
        mean_g_i(i)=delta{i}'*g_inexact{i};
        mean_grad_g_i(:,i)=grad_g{i}*(delta{i}.*(g_inexact{i}-mean_g_i(i)));
        grad_g_i_t(i)=(g_i_t(Index_Out(i))-mean_g_i(i))/t;
    end

    grad_g_x=grad_g_i_x*lambda;
    mean_g=mean_g_i'*lambda;
    if option==1
        grad_g_t=(g_t-lambda'*(g_i_t(Index_Out(i))-t*grad_g_i_t))/t;
    end
    if option==2   % no compute the grad_g_t
        if con==1
            [f,f1,f2,hes_g]=myfun_con_inexact(n,num,x,3,Index_out, Index_Inner);
        else
            [f,f1,f2,hes_g]=myfun_obj(n,num,x,3);
        end
        [mean_hes_g_i,hes_g_compute]=myfun_hes_mean(hes_g,grad_g,delta);
        hes_g_xx=(mean_hes_g_i-hes_g_compute./u)*lambda;
        a=repmat(lambda,1,n)';
        a=reshape(a,n*m,1);
        b=reshape(grad_g_i_x,n*m,1);
        a=a.*b;
        c=reshape(a,n,m)*grad_g_i_x';
        hes_g_xx=hes_g_xx+1/u*(2*c-grad_g_x*grad_g_x');   % ignore -1/u*grad_g_x*grad_g_x' to make rank-one modification
        %             hes_g_xx=hes_g_xx+1/u*(2*reshape(c,n^2,1)-grad_g_x*grad_g_x');   % ignore -1/u*grad_g_x*grad_g_x' to make rank-one modification

        hes_g_xt=1./(u*t)*(grad_g_i_x*(lambda.*(-mean_g_i+mean_g)) +mean_grad_g_i*lambda);
        grad_g_t=[];
    end
    if option==3
        if con==1
            [f,f1,f2,hes_g]=myfun_con_inexact(n,num_con,x,3,Index_Out, Index_Inner);
            %                   hes_g=hes_con;
        else
            [f,f1,f2,hes_g]=myfun_obj(n,num,x,3);
            %                  hes_g=hes_f;
        end
        [mean_hes_f_i,hes_f_compute]=myfun_hes_mean(hes_g,grad_g,delta);
        hes_g_xx=reshape((mean_hes_f_i-hes_f_compute./u)*lambda,n,n);
        a=repmat(lambda,1,n)';
        a=reshape(a,n*m,1);
        b=reshape(grad_g_i_x,n*m,1);
        a=a.*b;
        c=reshape(a,n,m)*grad_g_i_x';
        hes_g_xx=hes_g_xx+1/u*(2*c-grad_g_x*grad_g_x');  % ignore -1/u*grad_g_x*grad_g_x' to make rank-one modification        end
        %             hes_g_xx=hes_g_xx+1/u*(2*reshape(c,n^2,1)-reshape(grad_g_x*grad_g_x',n^2,1));   % ignore -1/u*grad_g_x*grad_g_x' to make rank-one modification

        hes_g_xt=1./(u*t)*(grad_g_i_x*(lambda.*(-mean_g_i+mean_g)) +mean_grad_g_i*lambda);
        grad_g_t=(g_t-lambda'*(g_i_t(Index_Out(i))-grad_g_i_t))/t;
    end
end
return

function [ mean_hes_g_i,hes_g_compute]=myfun_hes_mean(hes_g,grad_g,delta);
global n;
m=size(delta,1);
mean_hes_g_i=zeros(n^2,m);
hes_g_compute=zeros(n^2,m);
for i=1:m
    l=length(delta{i});
    mean_hes_g_i(:,i)=hes_g{i}*delta{i};
    a=repmat(delta{i},1,n)';
    a=reshape(a,l*n,1);
    b=reshape(grad_g{i},l*n,1);
    a=reshape(a.*b,n,l);
    hes_g_compute(:,i)=reshape(a*grad_g{i}',n^2,1);
end
return